
// RichEditDlgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RichEditDlg.h"
#include "RichEditDlgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CRichEditDlgDlg dialog




CRichEditDlgDlg::CRichEditDlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRichEditDlgDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRichEditDlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_RICHEDIT21, m_rtf);
}

BEGIN_MESSAGE_MAP(CRichEditDlgDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_PRINT, &CRichEditDlgDlg::OnBnClickedPrint)
END_MESSAGE_MAP()


// CRichEditDlgDlg message handlers

BOOL CRichEditDlgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRichEditDlgDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRichEditDlgDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRichEditDlgDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CRichEditDlgDlg::OnBnClickedPrint()
{
	INT			nPage;
	CString		strPage;


	
	CPrintDialog printDialog(false,PD_ALLPAGES | PD_RETURNDC | PD_NOSELECTION | PD_HIDEPRINTTOFILE | PD_NOPAGENUMS);
	

	int r = printDialog.DoModal();
	if (r == IDCANCEL)
		return; // User pressed cancel, don't print.


	HDC hPrinterDC = printDialog.GetPrinterDC();
	CDC *pMyPrinterDC = CDC::FromHandle(hPrinterDC);
	

	// This code basically taken from MS KB article Q129860 
	
	FORMATRANGE fr;
	  int	  nHorizRes = GetDeviceCaps(hPrinterDC, HORZRES);
	  int	  nVertRes = GetDeviceCaps(hPrinterDC, VERTRES);
      int     nLogPixelsX = GetDeviceCaps(hPrinterDC, LOGPIXELSX);
	  int     nLogPixelsY = GetDeviceCaps(hPrinterDC, LOGPIXELSY);
	  LONG	  lTextLength;   // Length of document.
	  LONG	  lTextPrinted;  // Amount of document printed.

	 // Ensure the printer DC is in MM_TEXT mode.
	 SetMapMode ( hPrinterDC, MM_TEXT );


	  // Get the page width and height from the printer.
	  long lPageWidth =  ::MulDiv(pMyPrinterDC->GetDeviceCaps(HORZRES), 1440, pMyPrinterDC->GetDeviceCaps(LOGPIXELSX));	  
	  long lPageHeight = ::MulDiv(pMyPrinterDC->GetDeviceCaps(VERTRES), 1440, pMyPrinterDC->GetDeviceCaps(LOGPIXELSY));
	  CRect rcPage(0, 0, lPageWidth, lPageHeight);

	 // Rendering to the same DC we are measuring.
	  ZeroMemory(&fr, sizeof(fr));
	  fr.hdc = pMyPrinterDC->m_hDC;
	  fr.hdcTarget = pMyPrinterDC->m_hAttribDC;
	  fr.rc = rcPage;
	  fr.rcPage = rcPage;
	 // Default the range of text to print as the entire document.
	  fr.chrg.cpMin = 0;
	  fr.chrg.cpMax = -1;

	  m_rtf.SetTargetDevice(hPrinterDC,lPageWidth);



	  // Set up the print job (standard printing stuff here).
	  DOCINFO di;
	  ZeroMemory(&di, sizeof(DOCINFO));
	  di.cbSize = sizeof(DOCINFO);
	  di.lpszDocName = _T("Gnosis Explorer Notes");
	  // Do not print to file.
	  di.lpszOutput = NULL;
	 // Start the document.
	  pMyPrinterDC->StartDoc(&di);
	  
	  // Find out real size of document in characters.
	  lTextLength = m_rtf.GetTextLength();



	  nPage = 1;
	  do {



	     // Start the page.
		  pMyPrinterDC->StartPage();

		nPage++;
		
		fr.rc = rcPage;
		fr.rcPage = rcPage;
   
		lTextPrinted = m_rtf.FormatRange(&fr,FALSE);		
		m_rtf.DisplayBand(&fr.rc );

	    // Print last page.	    
		pMyPrinterDC->EndPage();
        


	    // If there is more text to print, adjust the range of characters
	     // to start printing at the first character of the next page.
		if (lTextPrinted < lTextLength)	{
			fr.chrg.cpMin = lTextPrinted;
			fr.chrg.cpMax = -1;
		}

	  } while ( (lTextPrinted < lTextLength)  );

	 // Tell the control to release cached information.
	  m_rtf.FormatRange(NULL,FALSE);
	 //SendMessage( EM_FORMATRANGE, 0, (LPARAM)NULL);


	pMyPrinterDC->EndDoc ();


	DeleteDC(hPrinterDC);
	pMyPrinterDC->DeleteDC();
}
